<template>
	<div class="container">
		<Breadcrumbs>
			<Breadcrumb title="Home" :to="`/?${buildQueryFromPath('/')}`">
				<template #icon>
					<Folder :size="20" decorative />
				</template>
			</Breadcrumb>
			<Breadcrumb
				v-for="(folder, index) in pathArray"
				:key="index"
				:title="folder"
				:to="`/?${buildQueryFromPath(buildPath(index))}`">
				{{ folder }}
			</Breadcrumb>
		</Breadcrumbs>
	</div>
</template>
<script>
// Unexplicable import error : Unknown custom element: <Breadcrumbs> - did you register the component correctly? For recursive components, make sure to provide the "name" option.
import Breadcrumbs from '@nextcloud/vue/dist/Components/Breadcrumbs'
import Breadcrumb from '@nextcloud/vue/dist/Components/Breadcrumb'
import Folder from 'vue-material-design-icons/Folder'

export default {
	name: 'PathBreadcrumbs',
	components: {
		Folder,
		Breadcrumbs,
		Breadcrumb,
	},
	computed: {
		currentFolder() {
			const res = this.$route.query.path
			return typeof res === 'undefined' ? '/' : res
		},

		pathArray() {
			const paths = this.currentFolder.replace(/^\//, '').split('/')
			if (paths.length >= 1 && paths[0] === '') paths.shift()
			return paths
		},
	},
	methods: {
		buildPath(index) {
			let str = ''
			for (let i = 0; i <= index; i++) {
				str += '/' + this.pathArray[i]
			}
			return str
		},
		buildQueryFromPath(providedPath) {
			return new URLSearchParams({ ...this.$route.query, path: providedPath }).toString()
		},
	},
}

</script>
<style>
	.container {
		display: inline-flex;
		margin-left: 3em;
		width: 100%;
	}
</style>
